const Promise = require('bluebird')
const retry = require('bluebird-retry')
const http = require('http')
const _ = require('underscore')
const co = require('co')

const request = Promise.method((url) => {
  return new Promise((resolve, reject) => {
    http.get(url, resolve).on('error', reject)
  })
})

const connect = co.wrap(function * (url) {
  console.log('Checking elasticearch...')
  var res = yield request(url)
  if (res.statusCode === 200) return 'ok'
  throw new Error('Elasticsearch is not available!')
})

module.exports = co.wrap(function * (elasticUrl, options) {
  if (!elasticUrl) {
    if (process.env.ELASTICSEARCH_PORT) elasticUrl = process.env.ELASTICSEARCH_PORT.replace('tcp://', 'http://')
  }
  if (!elasticUrl) throw new Error('Elasticurl is missing!')
  options = _.defaults(options, {
    timeout: 120
  })
  console.log(options)

  var conProm = () => connect(elasticUrl)
  var retries = Number(options.timeout)
  return retry(conProm, {max_tries: retries})
})
